#!/usr/bin/perl -w

# pabber is an attempt to add the functionally of the Personal Address
# Book found in Microsoft Exchange/Outlook. pabber will allow a user
# to search the Global Address Book and add users to pine's .addressbook
# file. It does this using LDAP routines that hook it into an Exchange
# server. Obviously, the user will need to have read access to such
# a beast.

# pabber is Copyright (c) 2000  Marc Richter - marc@vitinc.com
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.


use Net::LDAP qw(:all);
use Tk;

#initialize - switch to config file style for final

$ldap = Net::LDAP->new("usrymx04.merck.com") or die "Unable to access LDAP server!";

#bind for search results

$mesg = $ldap->bind( version => 3 );

# subroutine for search...modify it to meet my needs

    sub LDAPsearch
        {
          my ($ldap,$searchString,$attrs,$base) = @_ ;
          # if they don't pass a base... set it for them
          if (!$base ) { $base = "o=Merck"; }
          # if they don't pass an array of attributes...
          # set up something for them
          if (!$attrs ) { $attrs = ['cn','mail' ]; }
          my $result = $ldap->search (
                base    => "$base",
                scope   => "sub",
                filter  => "$searchString",
                attrs   =>  $attrs
                );
        }

my @Attrs = ();             # request all available attributes
                                # to be returned.
my $result = LDAPsearch($ldap,"sn=*",\@Attrs);

# need main windows with field for last name and search button
# then result fields, maybe with the results themselves in a pop-up
# list
# once the proper result are displayed, clicking an "Add" button
# will insert the viewed record into the .addressbook
